﻿using System;
using System.Collections.Generic;
using System.Linq;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace GenuisCalculate
{
    /// <summary>
    /// Une page vide peut être utilisée seule ou constituer une page de destination au sein d'un frame.
    /// </summary>
    public sealed partial class GenCalculate: UserControl
    {
        /// <summary>
        /// Constructor
        /// </summary>
        public GenCalculate()
        {
            InitializeComponent();
            TextBoxValeur.TextChanged += TextBoxValeur_TextChanged;
            Btn00.PointerEntered += Btn00_Click;
            Btn01.PointerEntered += Btn01_Click;
            Btn02.PointerEntered += Btn02_Click;
            Btn03.PointerEntered += Btn03_Click;
            Btn04.PointerEntered += Btn04_Click;
            Btn05.PointerEntered += Btn05_Click;
            Btn06.PointerEntered += Btn06_Click;
            Btn07.PointerEntered += Btn07_Click;
            Btn08.PointerEntered += Btn08_Click;
            Btn09.PointerEntered += Btn09_Click;
            BtnPlus.PointerEntered += BtnPlus_Click;
            BtnMoins.PointerEntered += BtnMoins_Click;
            BtnMulti.PointerEntered += BtnMulti_Click;
            BtnDivide.PointerEntered += BtnDivide_Click;
            BtnInverse.PointerEntered += BtnInverse_Click;
            BtnEnter.PointerEntered += BtnEnter_Click;
            BtnPourcent.PointerEntered += BtnPourcent_Click;
            BtnDel.PointerEntered += BtnDel_Click;
            BtnBack.PointerEntered += BtnDel_Click;
            BtnDelAll.PointerEntered += BtnDelAll_Click;
            BtnReverted.PointerEntered += BtnReverted_Click;
            BtnSquare.PointerEntered += BtnSquare_Click;
            BtnPoint.PointerEntered += BtnPoint_Click;
            IsOperation = false;
        }
        #region Value
        private float valeur;
        /// <summary>
        /// Value calculate
        /// </summary>
        public float Valeur
        {
            get { return valeur; }
            set { valeur = value; }
        }
        #endregion
        #region Result calculate
        private float resultCalculate;
        /// <summary>
        /// Result calculate
        /// </summary>
        public float ResultCalculate
        {
            get { return resultCalculate; }
            set { resultCalculate = value; }
        }
        #endregion
        #region Calculate action
        private CalculateAction calcAction;
        /// <summary>
        /// Calculate action
        /// </summary>
        public CalculateAction CalcAction
        {
            get { return calcAction; }
            set
            {
                calcAction = value;
                IsOperation = true;
            }
        }
        /// <summary>
        /// calculate action enumeration
        /// </summary>
        public enum CalculateAction
        {
            Addition = 1,
            Soustraction = 2,
            Multiply = 3,
            Divide = 4,
            Minus = 5
        }
        #endregion
        #region Caracter list
        /// <summary>
        /// Tape caracter  
        /// </summary>
        public List<char> TapeChar = new List<char>();
        #endregion
        #region Determined if is an operation
        /// <summary>
        /// Determined if is an operation
        /// </summary>
        public bool IsOperation { get; set; }
        #endregion
        #region Post last operand property
        /// <summary>
        /// Position Last Operand property
        /// </summary>
        /// <returns></returns>
        private int PosLastOperand()
        {
            var find = false;
            var i = TapeChar.Count - 1;
            while (i >= 0)
            {
                float res;
                if ((!float.TryParse(TapeChar[i].ToString(), out res) && TapeChar[i].ToString() != ","))
                {
                    if (find)
                        return i;
                    find = true;
                }
                i--;
            }
            return -1;
        }
        #endregion
        #region Last operand property
        /// <summary>
        /// Last operand property
        /// </summary>
        /// <returns></returns>
        private char LastOperand()
        {
            var i = TapeChar.Count - 1;
            while (i >= 0)
            {
                float res;
                if ((!float.TryParse(TapeChar[i].ToString(), out res) && TapeChar[i].ToString() != ","))
                {
                    return (TapeChar[i] != 'V' ? (TapeChar[i] != 'L' ? (TapeChar[i] != '+' ? (TapeChar[i] != '-' ? TapeChar[i] : 'n') : 'n') : 'n') : 'n');
                }
                i--;
            }
            return 'n';
        }
        #endregion
        #region Before last operand property
        /// <summary>
        /// Before last operand property
        /// </summary>
        /// <returns></returns>
        private char BeforeLastOperand()
        {
            var i = TapeChar.Count - 1;
            var find = false;
            while (i >= 0)
            {
                float res;
                if (!float.TryParse(TapeChar[i].ToString(), out res) && TapeChar[i].ToString() != ",")
                {
                    if (find)
                    {
                        return (TapeChar[i] != '+' ? (TapeChar[i] != '-' ? TapeChar[i] : 'n') : 'n');
                    }
                    find = true;
                }
                i--;
            }
            return 'n';
        }
        #endregion
        #region Compute method
        /// <summary>
        /// Compute behaviour
        /// </summary>
        public void Compute()
        {
            try
            {
                var lastOperand = LastOperand();
                var beforeLastOp = BeforeLastOperand();
                var globRes = string.Empty;
                float globalResult = 0;
                char op = 'o';
                int i = TapeChar.Count - 1;
                var result = string.Empty;
                TextBoxValeur.Text = string.Empty;
                while (i >= 0)
                {
                    float v;
                    if (op != 'o' && !(lastOperand != 'n' && lastOperand == op))
                    {
                        if (!string.IsNullOrEmpty(result))
                        {
                            try
                            {
                                globalResult = Operation(globalResult, float.Parse(result), op);
                                result = string.Empty;
                            }
                            catch (Exception) { }
                        }
                    }
                    else if ((lastOperand != 'n' && lastOperand == op) || (beforeLastOp != 'n'))
                    {
                        if (lastOperand == TapeChar[TapeChar.Count - 1] && lastOperand != 'L')
                            return;
                        var resultTemp2 = string.Empty;
                        var resultTemp1 = string.Empty;
                        i = PosLastOperand() + 1;
                        while ((i < TapeChar.Count && float.TryParse(TapeChar[i].ToString(), out v)) ||
                            (i >= 0 && TapeChar[i].ToString() == ","))
                        {
                            resultTemp1 = resultTemp1 + TapeChar[i].ToString();
                            i++;
                        }

                        var listNumberTemp = resultTemp1.ToCharArray();
                        foreach (var c in listNumberTemp)
                        {
                            resultTemp2 += c.ToString();
                        }
                        float valueNumber;
                        if (((!float.TryParse(TapeChar[TapeChar.Count - 1].ToString(), out valueNumber) &&
                            !string.IsNullOrEmpty(resultTemp2)) && (i >= 0 && TapeChar[i].ToString() != ",")) ||
                            beforeLastOp == 'L' || beforeLastOp == 'I' || beforeLastOp == 'V' || beforeLastOp == 'R')
                        {
                            switch (beforeLastOp.ToString())
                            {
                                case "*":
                                    ResultCalculate = string.IsNullOrEmpty(resultTemp2) ? ResultCalculate : ResultCalculate * float.Parse(resultTemp2);
                                    break;
                                case @"/":
                                    ResultCalculate = string.IsNullOrEmpty(resultTemp2) ? ResultCalculate : ResultCalculate / float.Parse(resultTemp2);
                                    break;
                                case "%":
                                    ResultCalculate = string.IsNullOrEmpty(resultTemp2) ? ResultCalculate : ResultCalculate % float.Parse(resultTemp2);
                                    break;
                                case "L":
                                    ResultCalculate = 1 / ResultCalculate;
                                    break;
                                case "I":
                                    ResultCalculate = ResultCalculate * -1;
                                    break;
                                case "R":
                                    ResultCalculate = ResultCalculate * -1;
                                    break;
                                case "V":
                                    ResultCalculate = float.Parse(Math.Sqrt(ResultCalculate).ToString());
                                    break;

                            }
                            var arrayResult = ResultCalculate.ToString().ToCharArray();
                            if (ResultCalculate < 0)
                            {
                                arrayResult = ("0" + ResultCalculate.ToString()).ToCharArray();
                            }
                            TapeChar.Clear();
                            foreach (var c in arrayResult)
                            {
                                TapeChar.Add(c);
                            }
                            TextBoxValeur.Text = ResultCalculate.ToString();
                        }
                        return;
                    }
                    var resultTemp = string.Empty;
                    while ((i >= 0 && float.TryParse(TapeChar[i].ToString(), out v)) || (i >= 0 && TapeChar[i].ToString() == ","))
                    {
                        resultTemp = resultTemp + TapeChar[i].ToString();
                        i--;
                    }

                    var listNumber = resultTemp.ToCharArray().Reverse();
                    foreach (var c in listNumber)
                    {
                        result += c.ToString();
                    }
                    if (string.IsNullOrEmpty(TextBoxValeur.Text))
                    {
                        TextBoxValeur.Text = result;
                    }
                    if (i >= 0 && !float.TryParse(TapeChar[i].ToString(), out v) && (i >= 0 && TapeChar[i].ToString() != ","))
                    {
                        op = TapeChar[i];
                    }
                    i--;
                }
                if (!string.IsNullOrEmpty(result))
                {
                    globalResult = Operation(globalResult, float.Parse(result), '+');
                }
                this.ResultCalculate = globalResult;
            }
            catch (Exception) { }
        }
        #endregion
        #region Is operation last value property
        /// <summary>
        /// Determined if the operator is the last operator
        /// </summary>
        public bool IsOperationLastvalue { get; set; }
        #endregion
        #region Operation property
        /// <summary>
        /// Operation method
        /// </summary>
        /// <param name="a"></param>
        /// <param name="b"></param>
        /// <param name="c"></param>
        /// <returns></returns>
        public float Operation(float a, float b, char c)
        {
            switch (c)
            {
                case '+':
                    return a + b;
                case '-':
                    return a - b;
                case '%':
                    return a % b;
                case 'R':
                    return a * -1;
                case '*':
                    return a * b;
                case '/':
                    return a / b;
                default:
                    return a * -1;
            }
        }
        #endregion
        /// <summary>
        /// Generate calculate construct
        /// </summary>
        #region Button square click event
        /// <summary>
        /// Button square click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnSquare_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('V');
            Compute();
            TextBoxValeur.Text = ResultCalculate.ToString();
        }
        #endregion
        #region Button reverted click event
        /// <summary>
        /// Button reverted click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnReverted_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('L');
            Compute();
            TextBoxValeur.Text = ResultCalculate.ToString();
        }
        #endregion
        #region Button delete click event
        /// <summary>
        /// Button delete click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnDel_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TextBoxValeur.Text = "0";
            if (TapeChar.Count == 0)
                return;
            TapeChar.RemoveAt(TapeChar.Count - 1);
        }
        #endregion
        #region Button deletet all click event
        /// <summary>
        /// Button delete all click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnDelAll_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Clear();
            ResultCalculate = 0;
            TextBoxValeur.Text = "0";
        }
        #endregion
        #region Button pourcent click event
        /// <summary>
        /// Button pourcent click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnPourcent_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('%');
            Compute();
            TextBoxValeur.Text = ResultCalculate.ToString();
        }
        #endregion
        #region Button enter click event
        /// <summary>
        /// Button enter click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnEnter_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('+');
            Compute();
            TextBoxValeur.Text = ResultCalculate.ToString();
        }
        #endregion
        #region Button inverse click event
        /// <summary>
        /// Button inverse click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnInverse_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('R');
            Compute();
            TextBoxValeur.Text = ResultCalculate.ToString();
        }
        #endregion
        #region Button divide click event
        /// <summary>
        /// Button divide click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnDivide_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('/');
            Compute();
            TextBoxValeur.Text = ResultCalculate.ToString();
        }
        #endregion
        #region Button multiple click event
        /// <summary>
        /// Button multiple click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnMulti_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('*');
            Compute();
            TextBoxValeur.Text = ResultCalculate.ToString();
        }
        #endregion
        #region Button minus click event
        /// <summary>
        /// Button minus click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnMoins_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('-');
            Compute();
            TextBoxValeur.Text = ResultCalculate.ToString();
        }
        #endregion
        #region Button plus click event
        /// <summary>
        /// Button  plus click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnPlus_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('+');
            Compute();
            TextBoxValeur.Text = ResultCalculate.ToString();
        }
        private void BtnPoint_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            var count = 0;
            var find = false;
            var deleteAction = false;
            TapeChar.Add(',');
            foreach (var c in TapeChar)
            {
                if (c == '+' || c == '-' || c == '*' || c == '/')
                {
                    find = true;
                    count = 0;
                }
                else if (c != ',')
                    find = false;
                if (c == ',')
                    count++;
                if (find && count > 1)
                {
                    TapeChar.RemoveAt(TapeChar.Count - 1);
                    deleteAction = true;
                    break;
                }
            }

            if (!deleteAction && TapeChar[TapeChar.Count - 1] != ',')
            {
                Compute();
                TextBoxValeur.Text = ResultCalculate.ToString();
            }
            else
            {
                // TextBoxValeur.Text = ResultCalculate.ToString();
            }
        }
        #endregion
        #region Button 0 click event
        /// <summary>
        /// Button number 0 click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn00_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('0');
            Compute();

        }
        #endregion
        #region Button 1 click event
        /// <summary>
        /// Button number 1 click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn01_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('1');
            Compute();
        }
        #endregion
        #region Button 2 click event
        /// <summary>
        /// Button number 2 click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn02_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('2');
            Compute();
        }
        #endregion
        #region Button 3 click event
        /// <summary>
        /// Button number 3 click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn03_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('3');
            Compute();
        }
        #endregion
        #region Button 4 click event
        /// <summary>
        /// Button number 4 click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn04_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('4');
            Compute();
        }
        #endregion
        #region Button 5 click event
        /// <summary>
        /// Button number 5 click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn05_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('5');
            Compute();
        }
        #endregion
        #region Button 6 click event
        /// <summary>
        /// Button number 6 click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn06_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('6');
            Compute();
        }
        #endregion
        #region Button 7 click event
        /// <summary>
        /// Button number 7 click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn07_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('7');
            Compute();
        }
        #endregion
        #region Button 8 click event
        /// <summary>
        /// Button number 8 click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn08_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('8');
            Compute();
        }
        #endregion
        #region Button 9 click event
        /// <summary>
        /// Button number 9 click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn09_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            TapeChar.Add('9');
            Compute();
        }
        #endregion
        #region Text box value changed
        /// <summary>
        /// Text box value text changed
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TextBoxValeur_TextChanged(object sender, TextChangedEventArgs e)
        {
            var control = sender as TextBox;
            float value;
            if (float.TryParse(control.Text, out value))
            {
                Valeur = value;
            }
            else
            {
                control.Text = string.Empty;
            }
        }
        #endregion
        #region Addition method
        /// <summary>
        /// Addition behaviour
        /// </summary>
        /// <param name="a"></param>
        public void Addition(float a)
        {
            ResultCalculate = resultCalculate + a;
            CalcAction = CalculateAction.Addition;
            //TextBoxValeur.Text = ResultCalculate.ToString();
        }
        #endregion
        #region Substract method
        /// <summary>
        /// Substract method
        /// </summary>
        /// <param name="a"></param>
        public void Substract(float a)
        {
            ResultCalculate = resultCalculate - a;
            CalcAction = CalculateAction.Soustraction;
        }
        #endregion
        #region Multiply method
        /// <summary>
        /// Multiply method behaviour
        /// </summary>
        /// <param name="a"></param>
        public void Multiply(float a)
        {
            ResultCalculate = resultCalculate * a;
            CalcAction = CalculateAction.Multiply;
        }
        #endregion
        #region Divide method
        /// <summary>
        /// Divide method behaviour
        /// </summary>
        /// <param name="a"></param>
        public void Divide(float a)
        {
            if (a != 0)
            {
                ResultCalculate = resultCalculate / a;
            }
            CalcAction = CalculateAction.Divide;
        }
        #endregion
        #region Minus method
        /// <summary>
        /// Minus behaviour method
        /// </summary>
        public void Minus()
        {
            Valeur = Valeur * -1;
            TextBoxValeur.Text = "-" + TextBoxValeur.Text;
            CalcAction = CalculateAction.Minus;
            EnterValue(TextBoxValeur.Text);
        }
        #endregion
        #region Enter method
        /// <summary>
        /// Enter method behaviour
        /// </summary>
        public void Enter()
        {
            switch (CalcAction)
            {
                case CalculateAction.Addition:
                    Addition(Valeur);
                    break;
                case CalculateAction.Soustraction:
                    Substract(Valeur);
                    break;
                case CalculateAction.Multiply:
                    Multiply(Valeur);
                    break;
                case CalculateAction.Divide:
                    Divide(Valeur);
                    break;
                case CalculateAction.Minus:
                    Minus();
                    break;
                default:
                    ResultCalculate = Valeur;
                    break;
            }
        }
        #endregion
        #region Enter value method
        /// <summary>
        /// Enter value method
        /// </summary>
        /// <param name="a"></param>
        public void EnterValue(string a)
        {
            if (IsOperationLastvalue)
            {
                TextBoxValeur.Text = string.Empty;
            }
            if (CalcAction == CalculateAction.Minus)
            {
                ResultCalculate = float.Parse(a);
                return;
            }
            var valeur = a;
            float val;
            if (!string.IsNullOrEmpty(valeur))
            {
                if (valeur == "," || valeur == "-")
                {
                    Valeur = float.Parse(valeur.Replace(',', '.'));
                    if (ResultCalculate == 0)
                        ResultCalculate = Valeur;
                    TextBoxValeur.Text = valeur + TextBoxValeur.Text;
                }
                else if (float.TryParse(valeur, out val))
                {
                    TextBoxValeur.Text = !IsOperation || !IsOperationLastvalue ? TextBoxValeur.Text + val.ToString() : val.ToString();
                    if (!IsOperation && ResultCalculate == 0)
                    {
                        ResultCalculate = float.Parse(val.ToString());
                    }
                }
            }
            IsOperation = false;
        }
        #endregion
        #region Window mouse left button down event
        /// <summary>
        /// Window mouse left button down
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Window_MouseLeftButtonDown(object sender, EventArgs e)
        {
          
        }
        #endregion
        
        /// <summary>
        /// Parent window
        /// </summary>
        public Window Parent { get; set; }
        #region Close event click
        /// <summary>
        /// Click event behaviour
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void MetataDataClose_Click(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            if (Parent != null)
            Parent.Close();
        }
        #endregion

    }
}
